#ifndef _STRING_INCLUDED_
#define _STRING_INCLUDED_     /* definujeme, ze je inkludovan string.h */
/*
 *  string.h
 *  ruzne prace pro praci se stringy
 *  kopirovani, porovnavani, presouvani...  
 *  funkce:
 *    putchar()     - vytiskne znak
 *    puts()        - vytiskne string (neformatovane)
 *    strcpy()      - natavi string
 *    strcat()      - spoji dva stringy
 *    getchar()     - sejme znak z klavesnice, vrati jako [int]
 *    gets()        - sejme string z klavesnice
 */  


#include <asm.h>  /* putch() */

/*
 *  putchar()
 *  vytiskne ASCII znak, pokud je vstup 0x08 (backspace), umaze jeden znak
 */ 
void putchar(char s) {
  if(s == '\b') {     /* backspace */
    putch('\b');
    putch(' ');
    putch('\b');
  } else {
    putch(s);
  }  
}

/*
 *  puts()
 *  vstup: ukazatel na string, ktery se bude tisknout na vystup 
 *  vystup: void
 */
void puts(const char *str) {
  int i;
  for(i = 0; str[i] != '\0' ; i++) {
    putchar(str[i]);
  } 
}

/*
 *  strcpy()
 *  zkopiruje src do dest zakonceny '\0'
 */ 
char *strcpy(char * dest,const char *src) {
char *tmp = dest;
  while ((*dest++ = *src++) != '\0');
    return tmp;
}

/*
 *  strcat()
 *  zkopiruje string pSrc na konec stringu pDst,
 *  spoji string pDst a pSrc, vrati v pDst... 
 */ 
char *strcat(char * pDst, const char *pSrc) {
    char *r = pDst;

    while (*pDst != '\0')
        pDst++;

    while ((*pDst++ = *pSrc++) != '\0')
        continue;

    return r;
}

/*
 *  getchar()
 *  sejme znak z klavesnice a vrati ho jako [int] 
 */ 
int getchar() {
 char character = 0;
 character = getch();

 return (int) character;
}

/*
 *  gets() 
 *  sejme string z klavesnice o maximalni delce <size>, kazdy znak vytiskne na monitor
 */ 
char *gets(char *cs, int size) {
  unsigned int counter = 0;
  unsigned char c = '\0';
  char *s;

  s = cs;
  while (1) {
  if(counter >= size) break;
  c = getch();
  if(c == '\r') break;
  if(c == '\n') break;
  if(c == '\0') break;
  if(c == '\t') c = ' ';

    if(!(counter == 0 && c == '\b')) {
      putchar(c);
    }
    if( c == '\b' ) {
      if (counter > 0)
      counter--;
    }
    else {
      *(s+(counter++)) = c;
    }
  }
  puts("\r\n");
  *(s+(counter++)) = '\0';
  return s;
}

#endif
